// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.18.1
// source: journals/journal_service.proto

package journals

import (
	context "context"
	data "gitlab.com/skllzz/jmot/gojmot-client/pb/keeper/data"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// OperatorClient is the client API for Operator service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type OperatorClient interface {
	// добавление или обновление записи в журнале, возвращает прежнее значение элемента, если оно было
	Append(ctx context.Context, in *AppendRequest, opts ...grpc.CallOption) (*data.Item, error)
	// чтение данных журнала
	Read(ctx context.Context, in *ReadRequest, opts ...grpc.CallOption) (Operator_ReadClient, error)
	// последнее актуальное значение элемента в журнале (вернет ошибку если элемент не найден)
	Value(ctx context.Context, in *ValueRequest, opts ...grpc.CallOption) (*data.Item, error)
}

type operatorClient struct {
	cc grpc.ClientConnInterface
}

func NewOperatorClient(cc grpc.ClientConnInterface) OperatorClient {
	return &operatorClient{cc}
}

func (c *operatorClient) Append(ctx context.Context, in *AppendRequest, opts ...grpc.CallOption) (*data.Item, error) {
	out := new(data.Item)
	err := c.cc.Invoke(ctx, "/journals.Operator/Append", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *operatorClient) Read(ctx context.Context, in *ReadRequest, opts ...grpc.CallOption) (Operator_ReadClient, error) {
	stream, err := c.cc.NewStream(ctx, &Operator_ServiceDesc.Streams[0], "/journals.Operator/Read", opts...)
	if err != nil {
		return nil, err
	}
	x := &operatorReadClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Operator_ReadClient interface {
	Recv() (*data.Item, error)
	grpc.ClientStream
}

type operatorReadClient struct {
	grpc.ClientStream
}

func (x *operatorReadClient) Recv() (*data.Item, error) {
	m := new(data.Item)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *operatorClient) Value(ctx context.Context, in *ValueRequest, opts ...grpc.CallOption) (*data.Item, error) {
	out := new(data.Item)
	err := c.cc.Invoke(ctx, "/journals.Operator/Value", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// OperatorServer is the server API for Operator service.
// All implementations should embed UnimplementedOperatorServer
// for forward compatibility
type OperatorServer interface {
	// добавление или обновление записи в журнале, возвращает прежнее значение элемента, если оно было
	Append(context.Context, *AppendRequest) (*data.Item, error)
	// чтение данных журнала
	Read(*ReadRequest, Operator_ReadServer) error
	// последнее актуальное значение элемента в журнале (вернет ошибку если элемент не найден)
	Value(context.Context, *ValueRequest) (*data.Item, error)
}

// UnimplementedOperatorServer should be embedded to have forward compatible implementations.
type UnimplementedOperatorServer struct {
}

func (UnimplementedOperatorServer) Append(context.Context, *AppendRequest) (*data.Item, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Append not implemented")
}
func (UnimplementedOperatorServer) Read(*ReadRequest, Operator_ReadServer) error {
	return status.Errorf(codes.Unimplemented, "method Read not implemented")
}
func (UnimplementedOperatorServer) Value(context.Context, *ValueRequest) (*data.Item, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Value not implemented")
}

// UnsafeOperatorServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to OperatorServer will
// result in compilation errors.
type UnsafeOperatorServer interface {
	mustEmbedUnimplementedOperatorServer()
}

func RegisterOperatorServer(s grpc.ServiceRegistrar, srv OperatorServer) {
	s.RegisterService(&Operator_ServiceDesc, srv)
}

func _Operator_Append_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AppendRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(OperatorServer).Append(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/journals.Operator/Append",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(OperatorServer).Append(ctx, req.(*AppendRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Operator_Read_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ReadRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(OperatorServer).Read(m, &operatorReadServer{stream})
}

type Operator_ReadServer interface {
	Send(*data.Item) error
	grpc.ServerStream
}

type operatorReadServer struct {
	grpc.ServerStream
}

func (x *operatorReadServer) Send(m *data.Item) error {
	return x.ServerStream.SendMsg(m)
}

func _Operator_Value_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ValueRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(OperatorServer).Value(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/journals.Operator/Value",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(OperatorServer).Value(ctx, req.(*ValueRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Operator_ServiceDesc is the grpc.ServiceDesc for Operator service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Operator_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "journals.Operator",
	HandlerType: (*OperatorServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Append",
			Handler:    _Operator_Append_Handler,
		},
		{
			MethodName: "Value",
			Handler:    _Operator_Value_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Read",
			Handler:       _Operator_Read_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "journals/journal_service.proto",
}
